#Problem 1: K-means

generateFourClusters <- function() 
{
	#generate the first cluster
	Sigma <- matrix(c(0.5,0,0,0.5),2,2)
	firstCenter <- c(-6,0)
	firstCluster <- mvrnorm(n = 50, firstCenter, Sigma)
	
	#generate the second cluster
	secondCenter <- c(-2,0)
	secondCluster <- mvrnorm(n = 50, secondCenter, Sigma)
	
	#generate the third cluster
	Sigma <- matrix(c(1,0,0,1),2,2)
	thirdCenter <- c(2,0)
	thirdCluster <- mvrnorm(n = 50, thirdCenter, Sigma)
	
	#generate the fourth cluster
	fourthCenter <- c(6,0)
	fourthCluster <- mvrnorm(n = 50, fourthCenter, Sigma)
	
	dataset <- rbind(firstCluster, secondCluster, thirdCluster, fourthCluster)
	colnames(dataset) <- c("x", "y")
	
	#######################################################################
	# fill out your code here, plot K against within cluster sum of squares

	
	#######################################################################
	
	return(dataset)
}

standardization <- function(dataset)
{
	# coupute the mean and variance of data
	n <- dim(dataset)[1]
	dataset.mean <- colMeans(dataset)
	dataset.var <- cov(dataset)

	#######################################################################
	# fill out your code here to standardize the data, make sure its covariable matrix 
	# is identity matrix and mean is (0,0)


	#######################################################################


	#######################################################################
	# copy the code to plot K against within cluster sum of squares from generateFourClusters()


	#######################################################################
	
	colnames(standardizedDataset) <- c("x", "y")
	return(standardizedDataset)
}

Kmeans <- function(dataset, K)
{
	# run K-means on dataset
	cl <- kmeans(dataset, K, nstart = 20)
	plot(dataset, col = cl$cluster)
	points(cl$centers, col = 1:K, pch = 8, cex=2)
}


#Problem 3: Hierarchical Clustering

#define a function for coloring and resizing node elements:
colLab <- function(n)
{
  if(is.leaf(n))
    {
    a <- attributes(n)
    if ( length(which(blues == a$label)) == 1 )
      {
		attr(n, "nodePar") <- c(a$nodePar, list(lab.col = "blue", lab.cex=.7, col="blue", cex=pop[n], pch=16 ))
      }
    else
      {
		attr(n, "nodePar") <- c(a$nodePar, list(lab.col = "red", lab.cex=.7, col="red", cex=pop[n], pch=16))
      }  
    }
  n
}

electionClustering <- function() 
{
	data <- read.table("election.data", sep="\t", header=T, row.names=1)

	# initial clustering
	# hc <- hclust(dist(data), "ave")
	# plot(hc, hang=.5, cex=0.8)
	Bush <- data$Bush
	Kerry <- data$Kerry
	
	#######################################################################
	# normalize population influence
	# fill out your code here, only two lines

	#######################################################################

	#re-cluster
	hc <- hclust(dist(data), "ave")
	dend <- as.dendrogram(hc)

	#calculate total votes per county and scale, generate lists of red and blue counties
	pop <<- log((Bush + Kerry) / sum(Bush + Kerry) * 1000, 10)
	reds <<- as.factor(row.names(data[data$Bush > data$Kerry, ]))
	blues <<- as.factor(row.names(data[data$Kerry > data$Bush, ]))


	#re-plot the dendrogram	
	dend_colored <- dendrapply(dend, colLab)
	plot(dend_colored, main="CA 2004 Election Results by County")
	legend(x=55, y=14, legend=c("Dem", "Rep"), col=c("blue", "red"), cex=0.5, pch=16)
}
