library(pixmap)
library(e1071)

############################################################
# Problem 4

p4a = function() {
  YX = t(read.table('house-votes-84.dat'))
  Y = YX[1,] + 2 # Labels (1, 3)
  X = YX[2:dim(YX)[1],] # Data
  X = X - rowSums(X)/dim(X)[2] # Center the data

  # Project X onto first two eigenvectors and plot the points
  # INSERT CODE HERE
}

p4b = function() {
  YX = t(read.table('house-votes-84.dat'))
  Y = YX[1,] + 2 # Labels (1, 3)
  X = YX[2:dim(YX)[1],] # Data
  X = X - rowSums(X)/dim(X)[2] # Center the data

  # Project t(X) onto first two eigenvectors and plot the variables
  # Use plot() and text()
  # INSERT CODE HERE
}

############################################################
# Problem 5

# All images will be of this size (imageDim[1] rows, imageDim[2] cols)
# Returns the data matrix, where each column is an image
loadFaces = function(directory) {
  files = dir(directory, full.names = TRUE)
  #files = files[1:100] # Only use the first few examples for speed

  # Read in data
  faces = c()
  n = length(files)
  for (i in 1:n) {
    print(files[i])
    pic = getChannels(read.pnm(files[i])) # Get the matrix of pixels
    imageDim <<- dim(pic)
    pic = c(pic); d = length(pic) # Linearize the pixels
    if (length(faces) == 0) faces = matrix(0, d, n)
    faces[,i] = pic
  }
  faces
}
loadAllFaces = function() {
  trainPos <<- loadFaces('faces/train/positive')
  trainNeg <<- loadFaces('faces/train/negative')
  testPos  <<- loadFaces('faces/test/positive')
  testNeg  <<- loadFaces('faces/test/negative')

  # Data matrix with all examples
  X <<- cbind(trainPos, trainNeg)
}

# Given a vector of pixels, plot it.
plotImg = function(pixels) {
  plot(pixmapGrey(matrix((pixels-min(pixels))/(max(pixels)-min(pixels)), imageDim[1], imageDim[2])))
}

##############################
# (a), (b)

reconstruct = function(x) {
  # Reconstruction experiment of faces
  # Compute PCA on trainPos
  # INSERT 1 LINE OF CODE HERE

  reconError = c()
  par(mfcol=c(2, 1))
  for (k in seq(1, dim(trainPos)[2], by=1)) {
    # Set xx = reconstruction of x using first k principal components
    # INSERT 1 LINE OF CODE HERE
    #plotImg(x); plotImg(xx); readline()
    reconError[k] = sum((x-xx)**2)
    print(c(k, reconError[k]))
  }
  par(mfcol=c(1, 1))
  plot(reconError)
}

##############################
# (c)

pcaClassification = function() {
  # Compute PCA on X
  # INSERT 1 LINE OF CODE HERE

  # Use top k eigenvectors
  transformFeaturesCreator = function(k) {
    function(X) {
      # Project X onto the first k principal components
      # INSERT 1 LINE OF CODE HERE
    }
  }

  # Evaluate classification using only a subset of eigenvectors
  K = dim(X)[2] # Maximum number of principal components
  errors = c()
  kk = 1
  while (kk <= K) {
    k = round(kk)
    errors[k] = evaluateFeatures(transformFeaturesCreator(k), trainPos, trainNeg, testPos, testNeg)
    print(c(k, errors[k]))
    if (kk < 20) kk = kk + 1 else kk = kk * 1.5
  }
  plot(errors)
}

# transformFeatures: takes a data matrix and transforms it
# Return error rate
evaluateFeatures = function(transformFeatures, trainPos, trainNeg, testPos, testNeg) {
  # Transform feature vectors
  trainPos = transformFeatures(trainPos)
  trainNeg = transformFeatures(trainNeg)
  testPos = transformFeatures(testPos)
  testNeg = transformFeatures(testNeg)

  trainy = t(cbind(t(rep(+1, dim(trainPos)[2])), t(rep(-1, dim(trainNeg)[2]))))
  testy = t(cbind(t(rep(+1, dim(testPos)[2])), t(rep(-1, dim(testNeg)[2]))))
  trainx = cbind(trainPos, trainNeg)
  testx = cbind(testPos, testNeg)

  # Run nearest neighbor classifier
  numErrors = 0
  for (i in seq(1, dim(testx)[2])) { # For each test point...
    minDist = Inf
    besty = NA
    for (j in seq(1, dim(trainx)[2])) { # Find closest training point...
      dist = sum((trainx[,j] - testx[,i])**2)
      if (dist < minDist) {
        minDist = dist 
        besty = trainy[j]
      }
    }
    if (besty != testy[i]) numErrors = numErrors + 1
  }
  numErrors / dim(testx)[2]
}
